
/**
 * Beispiele für diverse Graphen
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class Beispiele
{
    GraphMatrix g;
    Lesen l;
    
    /**
     * Legt das Graphenobjekt an.
     */
    Beispiele ()
    {
        g = new GraphMatrix();
        l = new Lesen();
    }

    /**
     * Legt einen Graphen für eine Abiturfahrt an.
     * Am Ende Ausgabe der Adjazenzmatrix zur Kontrolle
     */
    void AusführenAbiturfahrt()
    {
        g.ZurückSetzen();
        if (l.LesenDatenbank("Abiturfahrt.grdb", g))
        {
            //g.Ausgeben();
        }
    }

    /**
     * Legt einen Graphen für den süddeutschen Teil des Autobahnnetzes an.
     * Am Ende Ausgabe der Adjazenzmatrix zur Kontrolle
     */
    void AusführenAutobahn()
    {
        g.ZurückSetzen();
        if (l.LesenDatenbank("Autobahn.grdb", g))
        {
            //g.Ausgeben();
        }
    }
 
    /**
     * Legt einen Graphen für das deutsche ICE-Netz an.
     * Am Ende Ausgabe der Adjazenzmatrix zur Kontrolle
     */
    void AusführenICE()
    {
        g.ZurückSetzen();
        if (l.LesenDatenbank("ICENetz.grdb", g))
        {
            //g.Ausgeben();
        }
    }

    /**
     * Legt einen zusammenhängenden Graphen an.
     * Am Ende Ausgabe der Adjazenzmatrix zur Kontrolle
     */
    void AusführenBeispielgraph()
    {
        g.ZurückSetzen();
        if (l.LesenDatenbank("Beispielgraph.grdb", g))
        {
            //g.Ausgeben();
        }
    }

    /**
     * Legt einen nicht zusammenhängenden Graphen an.
     * Am Ende Ausgabe der Adjazenzmatrix zur Kontrolle
     */
    void AusführenBeispielgraph2()
    {
        g.ZurückSetzen();
        if (l.LesenDatenbank("Beispielgraph2.grdb", g))
        {
            //g.Ausgeben();
        }
    }

    
    /**
     * Führt den Dijkstra-Algorithmus vom Startknoten zum Zielknoten durch
     * @param nameStartKnoten der Name des Startknotens
     * @param nameZielKnoten der Name des Zielknotens
     */
    void DijkstraAusführen (String nameStartKnoten, String nameZielKnoten)
    {
        if (g != null)
        {
            g.DijkstraAusführen(g.KnotenNummerGeben(nameStartKnoten), g.KnotenNummerGeben(nameZielKnoten));
        }
    }
}
